//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//

void MARCH() {
  marchOddLRL();    delay(100);
  marchEvenLRL();   delay(500);
  marchLR();        delay(0);
  marchRL();        delay(500);
  marchOuter2Center();  delay(100);
  marchCenter2Outer();  delay(500);
  fillO2C();        delay(100);
  fillC2O();        delay(500);
  marchClmnsL2R();  delay(100);
  marchClmnsR2L();  delay(500);
}

//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
void marchOddLRL() {               // March the odd-numbered LEDs back and forth, starting with the first.
  matrix1.setBrightness(100);      // 0-255. 127 = half-brightness.
  matrix2.setBrightness(100);
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  for (i = 0; i < ledCnt; i = i + 2)     {
    matrix1.drawPixel(i, 0, aC[rndClr1]);
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.show();  matrix2.show();
    delay(veryFast);
    matrix1.drawPixel(i, 0, BLACK);
    matrix2.drawPixel(i, 0, BLACK);
  }
  blankMatrices();
  delay(normal);
  for (i = ledCnt; i >= 0; i = i - 2) {
    matrix1.drawPixel(i, 0, aC[rndClr1]);
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.show();  matrix2.show();
    delay(veryFast);
    matrix1.drawPixel(i, 0, BLACK);
    matrix2.drawPixel(i, 0, BLACK);
  }
  blankMatrices();
}
//------------------//
void marchEvenLRL() {              // March the even-numbered LEDs back and forth, starting with the second.
  matrix1.setBrightness(100);      // 0-255. 127 = half-brightness.
  matrix2.setBrightness(100);
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  for (i = 1; i <= ledCnt; i = i + 2) {
    matrix1.drawPixel(i, 0, aC[rndClr1]);
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.show();  matrix2.show();
    delay(veryFast);
    matrix1.drawPixel(i, 0, BLACK);
    matrix2.drawPixel(i, 0, BLACK);
  }
  blankMatrices();
  delay(normal);
  for (i = ledCnt - 1; i >= 0; i = i - 2) {
    matrix1.drawPixel(i, 0, aC[rndClr1]);
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.show();  matrix2.show();
    delay(veryFast);
    matrix1.drawPixel(i, 0, BLACK);
    matrix2.drawPixel(i, 0, BLACK);
  }
  blankMatrices();
}
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
void marchLR() {                     // Left-Right March. Briefly display each LED sequentially.
  matrix1.setBrightness(255);        // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 12);  // Colour palette contains BLACK at position 24. (random(min,max - 1).
  int rndClr2  = random(12, 24);
  for (i = 0; i < ledCnt; i++) {
    matrix1.drawPixel(i, 0, aC[rndClr1]);   // (int16_t x, int16_t y, uint16_t color);
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.show();
    matrix2.show();
    delay(10);
    matrix1.drawPixel(i, 0, BLACK);             // Blank out current pixel before next pixel is drawn.
    matrix2.drawPixel(i, 0, BLACK);
    matrix1.show();
    matrix2.show();
  }
}
//------------------//
void marchRL() {                     // Right-Left March. Briefly display each LED sequentially.
  matrix1.setBrightness(255);        // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 12);  // Colour palette contains BLACK at position 24. (random(min,max - 1).
  int rndClr2  = random(12, 24);
  for (i = ledCnt; i >= 0; i--) {
    matrix1.drawPixel(i, 0, aC[rndClr1]);
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.show();
    matrix2.show();
    delay(10);
    matrix1.drawPixel(i, 0, BLACK);   // Blank out current pixel before next pixel is drawn.
    matrix2.drawPixel(i, 0, BLACK);
    matrix1.show();
    matrix2.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
void marchOuter2Center() {                  // Sequentially light each LED from outer to inner (0 to 31, 63 to 32 simultaneously).
  matrix1.setBrightness(255);               // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  int ledCntTMP = ledCnt - 1;
  for (i = 0; i <= ledCnt / 2; i++) {                 // i <= 32.
    matrix1.drawPixel(i, 0, aC[rndClr1]);         // 0 to 31.
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.drawPixel(ledCntTMP, 0, aC[rndClr1]); // 63 to 32.
    matrix2.drawPixel(ledCntTMP, 0, aC[rndClr2]);
    matrix1.show();   matrix2.show();
    delay(veryFast);

    matrix1.drawPixel(i, 0, BLACK);         // Sequentially blank 0 to 31.
    matrix2.drawPixel(i, 0, BLACK);
    matrix1.drawPixel(ledCntTMP, 0, BLACK); // Sequentially blank 63 to 31.
    matrix2.drawPixel(ledCntTMP, 0, BLACK);
    matrix1.show();   matrix2.show();
    ledCntTMP = ledCntTMP - 1;              // ledCntTMP--
  }
}
//------------------//
void marchCenter2Outer() {                  // Sequentially light each LED from inner to outer (32 to 0, 31 to 63 simultaneously).
  matrix1.setBrightness(255);               // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  for (i = 0; i < ledCnt / 2 + 1; i++) {                    // i <= 32.
    matrix1.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);  // 0 to 31.
    matrix2.drawPixel(ledCnt / 2 + i, 0, aC[rndClr2]);
    matrix1.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);  // 63 to 32.
    matrix2.drawPixel(ledCnt / 2 - i, 0, aC[rndClr2]);
    matrix1.show();   matrix2.show();
    delay(veryFast);

    matrix1.drawPixel(ledCnt / 2 + i, 0, BLACK);  // Sequentially blank 0 to 31.
    matrix2.drawPixel(ledCnt / 2 + i, 0, BLACK);
    matrix1.drawPixel(ledCnt / 2 - i, 0, BLACK);  // Sequentially blank 63 to 31.
    matrix2.drawPixel(ledCnt / 2 - i, 0, BLACK);
    matrix1.show();   matrix2.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
void fillO2C()    {   // Sequentially light (one colour) from Outer to Center (0 to 31, 63 to 31) but do not extinquish previous one.
  matrix1.setBrightness(100);               // 0-255. 127 = half-brightness.
  matrix2.setBrightness(100);
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  int ledCntTMP = ledCnt - 1;
  for (i = 0; i <= ((ledCnt) / 2); i++) {               // i <= 32.
    matrix1.drawPixel(i, 0, aC[rndClr1]);           // 0 to 31
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.drawPixel(ledCntTMP, 0, aC[rndClr1]);   // 63 to 32.
    matrix2.drawPixel(ledCntTMP, 0, aC[rndClr2]);
    matrix1.show();   matrix2.show();
    ledCntTMP--;                                        // ledCntTMP = ledCntTMP - 1;
    delay(veryFast);
  }
  delay(250);
  blankMatrices();
}
//------------------//
void fillC2O()    {   // Sequentially light (one colour) from Center to Outer (4 to 0, 4 to 8) but do not extinquish previous one.
  matrix1.setBrightness(100);               // 0-255. 127 = half-brightness.
  matrix2.setBrightness(100);
  int rndClr1  = random(0, 24);
  int rndClr2  = random(0, 24);
  int ledCntTMP = ledCnt / 2;
  for (i = ledCnt / 2; i >= 0; i--) {                  // i <= 4. (8 / 2).
    matrix1.drawPixel(i, 0, aC[rndClr1]);          // 4 to 0.
    matrix2.drawPixel(i, 0, aC[rndClr2]);
    matrix1.drawPixel(ledCntTMP, 0, aC[rndClr1]);  // 4 to 8.
    matrix2.drawPixel(ledCntTMP, 0, aC[rndClr2]);
    matrix1.show();   matrix2.show();
    ledCntTMP++;                                       // ledCntTMP = ledCntTMP + 1;
    delay(veryFast);
  }
  delay(250);
  blankMatrices();
}
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
void marchClmnsL2R() {  // Left & right matrices form one matrix of 16 columns. Illuminate each column from left to right, then extinguish from left to right.
  matrix1.setBrightness(255);                       // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8; j++) {
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, aC[rndClr1]); // Illuminate each left matrix column from left to right.
      matrix1.show();
      delay(5);
      matrix1.drawPixel(i + j, 0, BLACK);
      matrix1.show();
    }
  }
  for (j = 0; j < 8; j++) {
    for (i = 0; i < 64; i = i + 8) {
      matrix2.drawPixel(i + j, 0, aC[rndClr1]); // Illuminate each right matrix column from left to right.
      matrix2.show();
      delay(5);
      matrix2.drawPixel(i + j, 0, BLACK);
      matrix2.show();
    }
  }
}
//------------------//
void marchClmnsR2L() {  // Left & right matrices form one matrix of 16 columns. Illuminate each column from right to left, then extinguish from right to left.
  matrix1.setBrightness(255);                       // 0-255. 127 = half-brightness.
  matrix2.setBrightness(255);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8; j++) {
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix2.drawPixel(i - j, 0, aC[rndClr1]); // Illuminate each left matrix column from left to right.
      matrix2.show();
      delay(5);
      matrix2.drawPixel(i - j, 0, BLACK);
      matrix2.show();
    }
  }
  for (j = 0; j < 8; j++) {
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix1.drawPixel(i - j, 0, aC[rndClr1]); // Illuminate each right matrix column from left to right.
      matrix1.show();
      delay(5);
      matrix1.drawPixel(i - j, 0, BLACK);
      matrix1.show();
    }
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------// //------------------// //------------------//
void marchOddEven() {
  marchOddLRL();  delay(slow);      // March the odd-numbered LEDs back and forth, starting with the first.
  marchEvenLRL(); delay(verySlow);  // March the even-numbered LEDs back and forth, starting with the second.
}
//------------------//
void marchLRL() {
  marchLR(); delay(100);  // Left-Right March. Briefly display each LED sequentially.
  marchRL(); delay(500);  // Right-Left March. Briefly display each LED sequentially.
}
//------------------//
void marchColL2R2L() {
  marchClmnsL2R();    // Sequentially light each column of LEDs left to right while extinguishing the previous column.
  marchClmnsR2L();    // Sequentially light each column of LEDs right to left while extinguishing the previous column.
}
//------------------//
void marchO2C2O() {
  marchOuter2Center();  // Sequentially light each LED from outer to inner (0 to 4, 8 to 4 simultaneously).
  marchCenter2Outer();  // Sequentially light each LED from inner to outer (4 to 0, 4 to 8 simultaneously).
}
//------------------//
void fillO2C2O() {    // Sequentially light outer to inner, blank, then inner to outer without extinguishing the previous one.
  fillO2C();          // Fill outer to center.
  fillC2O();          // Fill center to outer.
}
//------------------//
