//------------------// //------------------// //------------------// //------------------// //------------------//
void WAVES() {
  wave16ClmnsL2R();        delay(normal);
  wave16ClmnsR2L();        delay(verySlow);

  wave8ClmnsM12L2R();      delay(normal);
  wave8ClmnsM12R2L();      delay(verySlow);

  waveHOuter2CenterM1M2(); delay(normal);
  waveHOuter2CenterM2M1(); delay(verySlow);
  waveHOuter2CenterM12();  delay(normal);

  waveHCenter2OuterM1M2(); delay(normal);
  waveHCenter2OuterM2M1(); delay(verySlow);
  waveHCenter2OuterM12();  delay(verySlow);

  waveVOuter2CenterM12();  delay(normal);
  waveVCenter2OuterM12();  delay(verySlow);

  waveDiagUL2LR2UL();      delay(normal);
  waveDiagUR2LL2UR();      delay(verySlow); 
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void wave16ClmnsL2R() {                             // D&E each of 16 columns, L to R.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  Serial.println("TEST1");
  for (j = 0; j < 8; j++) {
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, aC[rndClr1]); // Display each left matrix column from left to right.
      matrix1.show();
      delay(5);
    }
  }
  for (j = 0; j < 8; j++) {
    for (i = 0; i < 64; i = i + 8) {
      matrix2.drawPixel(i + j, 0, aC[rndClr1]); // Display each right matrix column from left to right.
      matrix2.show();
      delay(5);
    }
  }
  for (j = 0; j < 8; j++) {                         // Extinguish each left matrix column from left to right.
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, BLACK);
      matrix1.show();
      delay(5);
    }
  }
  for (j = 0; j < 8; j++) {                        // Extinguish each right matrix column from left to right.
    for (i = 0; i < 64; i = i + 8) {
      matrix2.drawPixel(i + j, 0, BLACK);
      matrix2.show();
      delay(5);
    }
  }
}
//------------------//
void wave16ClmnsR2L() {                             // D&E each of 16 columns, R to L.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8 ; j++) {
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix2.drawPixel(i - j, 0, aC[rndClr1]); // Display each left matrix column from left to right.
      matrix2.show();
      delay(5);
    }
  }
  for (j = 0; j < 8 ; j++) {
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix1.drawPixel(i - j, 0, aC[rndClr1]); // Display each right matrix column from left to right.
      matrix1.show();
      delay(5);
    }
  }
  for (j = 0; j < 8 ; j++) {                    // Extinguish each left matrix column from left to right.
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix2.drawPixel(i - j, 0, BLACK);
      matrix2.show();
      delay(5);
    }
  }
  for (j = 0; j < 8 ; j++) {                     // Extinguish each right matrix column from left to right.
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix1.drawPixel(i - j, 0, BLACK);
      matrix1.show();
      delay(5);
    }
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void wave8ClmnsM12L2R() {                           // D&E each of each matrix's 8 columns, L to R.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8; j++) {
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, aC[rndClr1]); // Display each left matrix column from left to right.
      matrix2.drawPixel(i + j, 0, aC[rndClr1]); // Display each right matrix column from left to right.
      matrix1.show();
      matrix2.show();
      delay(5);
    }
  }
  for (j = 0; j < 8; j++) {                         // Extinguish each left matrix column from left to right.
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, BLACK);
      matrix2.drawPixel(i + j, 0, BLACK);
      matrix1.show();
      matrix2.show();
      delay(5);
    }
  }
}
//------------------//
void wave8ClmnsM12R2L() {                           // D&E each of each matrix's 8 columns, R to L.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8; j++) {
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix2.drawPixel(i - j, 0, aC[rndClr1]); // Display each right matrix column from right to left.
      matrix1.drawPixel(i - j, 0, aC[rndClr1]); // Display each left matrix column from right to left.
      matrix2.show();
      matrix1.show();
      delay(5);
    }
  }
  for (j = 0; j < 8; j++) {
    for (i = 64 - 1; i >= 0; i = i - 8) {
      matrix2.drawPixel(i - j, 0, BLACK); // Extinguish each right matrix column from right to left.
      matrix1.drawPixel(i - j, 0, BLACK); // Extinguish each left matrix column from right to left.
      matrix2.show();
      matrix1.show();
      delay(5);
    }
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void waveHOuter2CenterM1M2() {        // On the left then right matrix, display each row starting at top and bottom simultaneously, meeting in the middle.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  int ledCntTempLeft = ledCnt - 1;
  int ledCntTempRight = ledCnt - 1;
  for (i = 0; i <= ledCnt / 2; i++) {                   // i <= 32.
    matrix1.drawPixel(i, 0, aC[rndClr1]);           // 0 to 32.  Left matrix.
    matrix1.drawPixel(ledCntTempLeft, 0, aC[rndClr1]);   // 64 to 32.
    matrix1.show();
    ledCntTempLeft = ledCntTempLeft - 1;                // ledCntTempLeft--
    delay(35);
  }
  for (i = 0; i <= ledCnt / 2; i++) {
    matrix2.drawPixel(i, 0, aC[rndClr1]);           // 0 to 32.  Right matrix.
    matrix2.drawPixel(ledCntTempRight, 0, aC[rndClr1]);   // 64 to 32.
    matrix2.show();
    ledCntTempRight = ledCntTempRight - 1;
    delay(35);
  }
  blankMatrices();
  delay(slow);
}
//------------------//
void waveHOuter2CenterM2M1() {        // On the right then left matrix, display each row starting at top and bottom simultaneously, meeting in the middle.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  int ledCntTempLeft = ledCnt - 1;
  int ledCntTempRight = ledCnt - 1;
  for (i = 0; i <= ledCnt / 2; i++) {                   // i <= 32.
    matrix2.drawPixel(i, 0, aC[rndClr1]);           // 0 to 32.  Left matrix.
    matrix2.drawPixel(ledCntTempRight, 0, aC[rndClr1]);   // 64 to 32.
    matrix2.show();
    ledCntTempRight = ledCntTempRight - 1;                // ledCntTempLeft--
    delay(35);
  }
  for (i = 0; i <= ledCnt / 2; i++) {
    matrix1.drawPixel(i, 0, aC[rndClr1]);           // 0 to 32.  Right matrix.
    matrix1.drawPixel(ledCntTempLeft, 0, aC[rndClr1]);   // 64 to 32.
    matrix1.show();
    ledCntTempLeft = ledCntTempLeft - 1;
    delay(35);
  }
  blankMatrices();
  delay(slow);
}
//------------------//
void waveHOuter2CenterM12() {  // On both matrices, display each row starting at top and bottom simultaneously, meeting in the middle.
  matrix1.setBrightness(64); matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  int ledCntTemp = ledCnt - 1;
  for (i = 0; i <= ledCnt / 2; i++) {                   // i <= 32.
    matrix1.drawPixel(i, 0, aC[rndClr1]);           // 0 to 32.  Left matrix.
    matrix1.drawPixel(ledCntTemp, 0, aC[rndClr1]);   // 64 to 32.
    matrix2.drawPixel(i, 0, aC[rndClr1]);           // 0 to 32.  Right matrix.
    matrix2.drawPixel(ledCntTemp, 0, aC[rndClr1]);   // 64 to 32.
    matrix1.show();
    matrix2.show();
    ledCntTemp = ledCntTemp - 1;
    delay(35);
  }
  blankMatrices();
  delay(slow);
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void waveHCenter2OuterM1M2() {                             // D&E center to outer matrix1 then matrix2.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (i = 0; i < ledCnt / 2 + 1; i++) {
    matrix1.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);
    matrix1.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);
    matrix1.show(); delay(35);
  }
  for (j = 0; j < ledCnt / 2 + 1; j++) {
    matrix1.drawPixel(ledCnt / 2 + j, 0, BLACK);
    matrix1.drawPixel(ledCnt / 2 - j, 0, BLACK);
    matrix1.show();
  }
  for (i = 0; i < ledCnt / 2 + 1; i++) {
    matrix2.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);
    matrix2.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);
    matrix2.show(); delay(35);
  }
  for (j = 0; j < ledCnt / 2 + 1; j++) {
    matrix2.drawPixel(ledCnt / 2 + j, 0, BLACK);
    matrix2.drawPixel(ledCnt / 2 - j, 0, BLACK);
    matrix2.show();
  }
}
//------------------//
void waveHCenter2OuterM2M1() {                             // D&E center to outer matrix2 then matrix1.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (i = 0; i < ledCnt / 2 + 1; i++) {
    matrix2.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);
    matrix2.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);
    matrix2.show(); delay(35);
  }
  for (j = 0; j < ledCnt / 2 + 1; j++) {
    matrix2.drawPixel(ledCnt / 2 + j, 0, BLACK);
    matrix2.drawPixel(ledCnt / 2 - j, 0, BLACK);
    matrix2.show();
  }
  for (i = 0; i < ledCnt / 2 + 1; i++) {
    matrix1.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);
    matrix1.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);
    matrix1.show(); delay(35);
  }
  for (j = 0; j < ledCnt / 2 + 1; j++) {
    matrix1.drawPixel(ledCnt / 2 + j, 0, BLACK);
    matrix1.drawPixel(ledCnt / 2 - j, 0, BLACK);
    matrix1.show();
  }
}
//------------------//
void waveHCenter2OuterM12() {   // The opposite of waveOuter2Center, starting at 63 and finishing at 32 in the center.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (i = 0; i < ledCnt / 2 + 1; i++) {
    matrix1.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);
    matrix1.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);
    matrix2.drawPixel(ledCnt / 2 + i, 0, aC[rndClr1]);
    matrix2.drawPixel(ledCnt / 2 - i, 0, aC[rndClr1]);
    matrix1.show();   matrix2.show();    delay(35);
  }
  for (j = 0; j < ledCnt / 2 + 1; j++) {
    matrix1.drawPixel(ledCnt / 2 + j, 0, BLACK);
    matrix1.drawPixel(ledCnt / 2 - j, 0, BLACK);
    matrix2.drawPixel(ledCnt / 2 + j, 0, BLACK);
    matrix2.drawPixel(ledCnt / 2 - j, 0, BLACK);
    matrix1.show();  matrix2.show();
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void waveVOuter2CenterM12() {                            // D&E vertical, outer to center, both matrices.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8; j++) {
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, BLUE);                 // Display each left matrix column from right to left.
      matrix1.show();
      delay(5);
    }
    for (i = ledCnt - 1; i >= 0; i = i - 8) {
      matrix2.drawPixel(i - j, 0, BLUE);                 // Display each right matrix column from left to right.
      matrix2.show();
      delay(5);
    }
  }

  for (j = 0; j < 8; j++) {                              // Extinguish each left matrix column from left to right.
    for (i = 0; i < 64; i = i + 8) {
      matrix1.drawPixel(i + j, 0, BLACK);
      matrix1.show();
      delay(5);
    }
    for (i = ledCnt - 1; i >= 0; i = i - 8) {            // Extinguish each right matrix column from right to left.
      matrix2.drawPixel(i - j, 0, BLACK);
      matrix2.show();
      delay(5);
    }
  }
}
//------------------//
void waveVCenter2OuterM12() {                            // D&E vertical, center to outer, both matrices.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  for (j = 0; j < 8; j++) {
    for (i = ledCnt - 1; i >= 0; i = i - 8) {
      matrix1.drawPixel(i - j, 0, BLUE);                 // Display each left matrix column from right to left.
      matrix1.show();
      delay(5);
    }
    for (i = 0; i < 64; i = i + 8) {
      matrix2.drawPixel(i + j, 0, BLUE);                 // Display each right matrix column from left to right.
      matrix2.show();
      delay(5);
    }
  }

  for (j = 0; j < 8; j++) {                              // Extinguish each left matrix column from right to left.
    for (i = ledCnt - 1; i >= 0; i = i - 8) {
      matrix1.drawPixel(i - j, 0, BLACK);
      matrix1.show();
      delay(5);
    }
    for (i = 0; i < 64; i = i + 8) {                     // Extinguish each right matrix column from left to right.
      matrix2.drawPixel(i + j, 0, BLACK);
      matrix2.show();
      delay(5);
    }
  }
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
void waveDiagUL2LR2UL() {                        // Diagonal, upper left to lower right to upper left, each matrix then both matrices.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  int diagL2R[64] = {0, 1, 8, 2, 9, 16, 3, 10, 17, 24, 4, 11, 18, 25, 32, 5, 12, 19, 26, 33, 40, 6, 13, 20, 27, 34, 41, 48, 7, 14, 21, 28,
                     35, 42, 49, 56, 15, 22, 29, 36, 43, 50, 57, 23, 30, 37, 44, 51, 58, 31, 38, 45, 52, 59, 39, 46, 53, 60, 47, 54, 61, 55, 62, 63
                    };
  for (i = 0; i < ledCnt; i = i + 1) {        // UL2LR: Display all.
    matrix1.drawPixel(diagL2R[i], 0, BLUE);
    matrix1.show();  delay(5);
  }
  for (i = 0; i < ledCnt; i = i + 1) {        // UL2LR: extinguish all.
    matrix1.drawPixel(diagL2R[i], 0, BLACK);
    matrix1.show();  delay(5);
  }
  delay(normal);
  for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LR2UL: Display all.
    matrix1.drawPixel(diagL2R[i], 0, BLUE);
    matrix1.show();  delay(5);
  }
  for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LR2UL: Display all.
    matrix1.drawPixel(diagL2R[i], 0, BLACK);
    matrix1.show();  delay(5);
  }
  /////////////
  for (i = 0; i < ledCnt; i = i + 1) {        // UL2LR: Display all.
    matrix2.drawPixel(diagL2R[i], 0, BLUE);
    matrix2.show();  delay(5);
  }
  for (i = 0; i < ledCnt; i = i + 1) {        // UL2LR: extinguish all.
    matrix2.drawPixel(diagL2R[i], 0, BLACK);
    matrix2.show();  delay(5);
  }
  delay(normal);
  for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LR2UL: Display all.
    matrix2.drawPixel(diagL2R[i], 0, BLUE);
    matrix2.show();  delay(5);
  }
  for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LR2UL: Display all.
    matrix2.drawPixel(diagL2R[i], 0, BLACK);
    matrix2.show();  delay(5);
  }
  /////////////
  for (i = 0; i < ledCnt; i = i + 1) {        // UL2LR: Display all.
    matrix1.drawPixel(diagL2R[i], 0, BLUE);
    matrix2.drawPixel(diagL2R[i], 0, BLUE);
    matrix1.show();  matrix2.show();  delay(5);
  }
  for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LR2UL: Display all.
    matrix1.drawPixel(diagL2R[i], 0, BLACK);
    matrix2.drawPixel(diagL2R[i], 0, BLACK);
    matrix1.show();  matrix2.show();  delay(5);
  }
}
//------------------//
void waveDiagUR2LL2UR() {                        // D&E diagonal, Upper Right to Lower Left to Upper Right, each matrix then both matrices.
  matrix1.setBrightness(64);  matrix2.setBrightness(64);
  int rndClr1  = random(0, 24);
  int diagL2R[64] = {7, 6, 15, 5, 14, 23, 4, 13, 22, 31, 3, 12, 21, 30, 39, 2, 11, 20, 29, 38, 47, 1, 10, 19, 28, 37, 46, 55, 0, 9, 18, 27,
                     36, 45, 54, 63, 8, 17, 26, 35, 44, 53, 62, 16, 25, 34, 43, 52, 61, 24, 33, 42, 51, 60, 32, 41, 50, 59, 40, 49, 58, 48, 57, 56
                    };
for (i = 0; i < ledCnt; i = i + 1) {        // UR2LL: Display all.
  matrix1.drawPixel(diagL2R[i], 0, BLUE);
  matrix1.show();  delay(5);
}
for (i = 0; i < ledCnt; i = i + 1) {        // UR2LL: extinguish all.
  matrix1.drawPixel(diagL2R[i], 0, BLACK);
  matrix1.show();  delay(5);
}
delay(normal);
for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LL2UR: Display all.
  matrix1.drawPixel(diagL2R[i], 0, BLUE);
  matrix1.show();  delay(5);
}
for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LL2UR: Display all.
  matrix1.drawPixel(diagL2R[i], 0, BLACK);
  matrix1.show();  delay(5);
}
/////////////
for (i = 0; i < ledCnt; i = i + 1) {        // UR2LL: Display all.
  matrix2.drawPixel(diagL2R[i], 0, BLUE);
  matrix2.show();  delay(5);
}
for (i = 0; i < ledCnt; i = i + 1) {        // UR2LL: extinguish all.
  matrix2.drawPixel(diagL2R[i], 0, BLACK);
  matrix2.show();  delay(5);
}
delay(normal);
for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LL2UR: Display all.
  matrix2.drawPixel(diagL2R[i], 0, BLUE);
  matrix2.show();  delay(5);
}
for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LL2UR: Display all.
  matrix2.drawPixel(diagL2R[i], 0, BLACK);
  matrix2.show();  delay(5);
}
/////////////
for (i = 0; i < ledCnt; i = i + 1) {        // UR2LL: Display all.
  matrix1.drawPixel(diagL2R[i], 0, BLUE);
  matrix2.drawPixel(diagL2R[i], 0, BLUE);
  matrix1.show();  matrix2.show();  delay(5);
}
for (i = ledCnt - 1; i >= 0; i = i - 1) {   // LL2UR: Display all.
  matrix1.drawPixel(diagL2R[i], 0, BLACK);
  matrix2.drawPixel(diagL2R[i], 0, BLACK);
  matrix1.show();  matrix2.show();  delay(5);
}
}
//------------------// //------------------// //------------------// //------------------// //------------------//
//------------------// //------------------// //------------------// //------------------// //------------------//
